Shell Reference Manual: org.gnome.Shell.SearchProvider

## org.gnome.Shell.SearchProvider org.gnome.Shell.SearchProvider — Search provider interface |

## Methods

    GetInitialResultSet   (IN  as     terms,
                           OUT as     results);
    GetSubsearchResultSet (IN  as     previous_results,
                           IN  as     terms,
                           OUT as     results);
    GetResultMetas        (IN  as     identifiers,
                           OUT aa{sv} metas);
    ActivateResult        (IN  s      identifier);

## Description

The interface used for integrating into GNOME Shell's search interface. This interface is deprecated, and org.gnome.Shell.SearchProvider2 should be used instead.

## Method Details

### The GetInitialResultSet() method

    GetInitialResultSet (IN  as terms,
                         OUT as results);

Called when the user first begins a search.

`IN as `terms``: | Array of search terms, which the provider should treat as logical AND.
`OUT as `results``: | An array of result identifier strings representing items which match the given search terms. Identifiers must be unique within the provider's domain, but other than that may be chosen freely by the provider.

### The GetSubsearchResultSet() method

    GetSubsearchResultSet (IN  as previous_results,
                           IN  as terms,
                           OUT as results);

Called when a search is performed which is a "subsearch" of the previous search, e.g. the method may return less results, but not more or different results.

This allows search providers to only search through the previous result set, rather than possibly performing a full re-query.

`IN as `previous_results``: | Array of results previously returned by GetInitialResultSet().
`IN as `terms``: | Array of updated search terms, which the provider should treat as logical AND.
`OUT as `results``: | An array of result identifier strings representing items which match the given search terms. Identifiers must be unique within the provider's domain, but other than that may be chosen freely by the provider.

### The GetResultMetas() method

    GetResultMetas (IN  as     identifiers,
                    OUT aa{sv} metas);

Return an array of meta data used to display each given result

`IN as `identifiers``: | An array of result identifiers as returned by GetInitialResultSet() or GetSubsearchResultSet()
`OUT aa{sv} `metas``: | A dictionary describing the given search result, containing a human-readable 'name' (string), along with the result identifier this meta is for, 'id' (string). Optionally, either 'gicon' (a serialized GIcon) or 'icon-data' (raw image data as (iiibiiay) - width, height, rowstride, has-alpha, bits per sample, channels, data) can be specified if the result can be better served with a thumbnail of the content (such as with images). A 'description' field (string) may also be specified if more context would help the user find the desired result.

### The ActivateResult() method

    ActivateResult (IN  s identifier);

Called when the users chooses a given result. The result should be displayed in the application associated with the corresponding provider.

This method is deprecated, and providers should implement ActivateResult2() instead.

`IN s `identifier``: | A result identifier as returned by GetInitialResultSet() or GetSubsearchResultSet()